#!/bin/bash
# 
# Version 1.0
# 21.05.2016
# 
# (c) Uwe von Royen
# 
# Vorrausetzung, damit das Script auch funktioniert!
# in /etc/sudeors am Dateiende:
# %users ALL=NOPASSWD: /bin/mount
# %users ALL=NOPASSWD: /bin/umount
# besser eine eigene gruppe anlegen
# > addgroup --gid 305 uvrnc
# > adduser uvr uvrnc
# > newgrp uvrnc
# einfügen!
# Update:
# 22.05.2015
# Wenn kein Netzwerk aktiv so ergibt die Ermittlung 'hostname -I' keine IP.
# die Varibale 'ipadresse_wks' erhält den Wert = Fehlerwert 0, somit muß kein Laufwerks-mounten statt finden.



# Variablen vom Administrator zu editieren
ipadressen_kreis="192.168."		# lokales Netzwerk
server_ip="192.168.0.245"       # NAS-Server
server_share="uwe"
mount_point="/media/uvr-server-01"
pwd="uvr"                       # Passwort

# Ab Hier nicht mehr editieren!
#
# Variablen Declaration
# $USER Umgebungsvariable vom System gesetzt!
user_name=""
user_gid=""
user_uid=""

was_soll_es_tun=""
status_schalter=""

# IP Adresse ermitteln
# 'ip addr show' oder '/sbin/ifconfig' oder 'hostname -I'-> Befehle in Terminal für IP-Ermittlung
ipadresse_wks="" 			  # IP-Adresse meines Arbeitsplatzes
#


# Start
user_name=`whoami`
user_gid=`id -g ${user_name}`
user_uid=`id -u ${user_name}`
ipadresse_wks=`hostname -I|grep $ipadressen_kreis`

was_soll_es_tun=$1 
#echo "Para:" $was_soll_es_tun " oder " $1


#echo "IP: |"${ipadresse_wks:0:8}"||" # substring herausscheiden! 
#echo $ipadresse_wks - $ipadressen_kreis

strlen=${#ipadresse_wks}


if [ "${was_soll_es_tun}" != "on" ] && [ "${was_soll_es_tun}" != "off" ]
then
    clear
    echo
    echo "Hinweis zum Mounten/Mappen oder uMounten/Freigeben:"
    echo "---------------------------------------------------"
    echo "Zum Mounten/Mappen der Laufwerke bitte Parameter: on mit übergeben!"
    echo "Zum uMounter/Freigeben der Laufwerke Parameter: off mit übergeben!"
    echo 
    echo "Beispiel: ./netdrive_on_off.sh on"
    echo
    echo
else    
    # echo "01"
	if [ $strlen != '0' ]
	then
		#echo "1"
		if [ ${ipadresse_wks:0:8} == $ipadressen_kreis ] 
		then
			# echo "2"
			# if  grep -qs $ipadressen_kreis /proc/mounts 
			if  grep -qs ${server_ip}/${server_share} /proc/mounts
			then
                #echo "mounted"
                status_schalter="on"
			else
				#echo "not mounted"
				status_schalter="off"
			fi
			
			if [ "${was_soll_es_tun}" == "on" ] && [  $status_schalter == "off" ]
			then
				sudo mount -t cifs //"${server_ip}"/$server_share $mount_point -o username="${user_name}",password="${pwd}",file_mode=0775,dir_mode=0775,uid=${user_uid},gid=${user_gid} 
			else
			    if [ "${was_soll_es_tun}" == "off" ] && [  $status_schalter == "on" ]
			    then
					sudo umount /$mount_point
				fi	
			fi
				
		fi
	else
	    clear
		echo
		echo "Hinweis zum Netzwerkstatus:"
		echo "---------------------------------------------------"
		echo "Der Rechner hat keine IP-Adresse!"
		echo "Überprüfen Sie mit 'ipconfig' den Netwerkstatus"
		echo
		echo "Mögliche Fehlquellen:"
		echo "- Netzwerkkabel nicht richtig angeschlossen!"
		echo "- Netzwerkkabel defekt?"
		echo "- Netzwerkkarte deaktiviert?"
		echo "- Treiber Probleme?"
		echo "- Defektes Bauteil? "
		echo "- Oh! böses Problem: Fragen Sie mal den Administrator .. ,-) "
		echo 	
	fi
fi
